/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-16
*
* */

#ifndef LS_STD_EVENT_REWORKED_HPP
#define LS_STD_EVENT_REWORKED_HPP

#include <ls-std/core/Class.hpp>
#include <memory>
#include <string>

namespace ls::std::event::reworked
{
  class Event : public ls::std::core::Class // TODO: put EventManager behind abstract or base class rather than using ls::std::core::Class
  {
    public:

      explicit Event(const ::std::string &_name);
      ~Event() noexcept override;

      [[nodiscard]] ::std::shared_ptr<ls::std::core::Class> getManager() const;
      [[nodiscard]] ls::std::event::reworked::Event of(const ::std::shared_ptr<ls::std::core::Class> &_manager) const;
      void setManager(const ::std::shared_ptr<ls::std::core::Class> &_manager);

    private:

      ::std::shared_ptr<ls::std::core::Class> manager{};
  };
}

#endif
