/*
* Author:          Patrick-Christopher Mattulat
* Company:         Lynar Studios
* E-Mail:          webmaster@lynarstudios.com
* Created:         2024-05-16
* Changed:         2024-05-17
*
* */

#ifndef LS_STD_EVENT_LISTENER_REWORKED_HPP
#define LS_STD_EVENT_LISTENER_REWORKED_HPP

#include <ls-std/core/Class.hpp>
#include <ls-std/event/reworked/Event.hpp>
#include <ls-std/event/reworked/type/EventTypes.hpp>

namespace ls::std::event::reworked
{
  class EventListener : public ::std::enable_shared_from_this<EventListener>, public ls::std::core::Class
  {
    public:

      explicit EventListener();
      ~EventListener() noexcept override;

      [[nodiscard]] ls::std::event::reworked::type::listener_id getId() const;
      void setId(ls::std::event::reworked::type::listener_id _id);
      [[maybe_unused]] bool subscribe(const ls::std::event::reworked::Event &_event, const ls::std::event::reworked::type::event_action &_action);

    private:

      ls::std::event::reworked::type::listener_id id{};

      void _requestListenerId(const ::std::shared_ptr<ls::std::core::Class> &_manager);
      [[nodiscard]] bool _subscribe(const ls::std::event::reworked::Event &_event, const ls::std::event::reworked::type::event_action &_action);
  };
}

#endif
